//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|                                                                                                                                                   FileMappingMT4.mqh |
//|                                                                                                                                                   Copyright  Zhunko |
//|30.03.2010 - 30.04.2010                                                                                                                            vadim@zhunko.ru    |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|    "FileMappingMT4.dll"      .                                                                      |
//|  "FileMappingMT4.dll"        "AIASM".                                                                   |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//|           .        ,       |
//|   .       .  "FileMapCreate()"  "FileMapCreateViewOfFile()"       |
//| NULL.   ,       "Simple",   ,    .      |
//|        .                                                                                                        |
//| ,      "Simple",             |
//|    .  ,      ,        .                           |
//|    "FileMapCreate()"   "FileMapOpen()"       ,           |
//|         "FileMapCloseHandle()".          |
//|   .      "FileMapViewOfFile()"                    |
//|  .                                                                                                                                    |
//|         (    )  1024.   |
//|     .                                                                                                   |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//| 83    10 .                                                                                                                                    |
//| 1.  .                                                                                                                                                    |
//| 2.              .                                           |
//| 3.         .                                                                                                          |
//| 4.                .                                    |
//| 5.         .                                                                                                        |
//| 6.                .                                   |
//| 7.       .                                                                                                               |
//| 8.              .                                         |
//| 9.       .                                                                                                             |
//|10.              .                                        |
//+----------------------------------------------------------------------------------------------------------------------------------------------------------------------+
//
#import "FileMappingMT4.dll"
 //
 //    .    
 //
 //======================================================================================================================================================================
 // 1.           /       
 //         .         ,  NULL.
 //                .            
 //          .      NULL.
 int FileMapCreate(int    hFileUser,    //    .
                   string sNameFileMap, //    .
                   int    nMemorySize); //      .
 //======================================================================================================================================================================
 // 2.    TRUE,       ,   FALSE.
 bool FileMapCheck(string sNameFileMap); //   .
 //======================================================================================================================================================================
 // 3.       .   TRUE     FALSE.
 bool FileMapClear(string sNameFileMap); //   .
 //======================================================================================================================================================================
 // 4.            .
 //         ,        .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseAll(string sNamePrefix); //    .
 //======================================================================================================================================================================
 // 5.      .   TRUE   ,  FALSE.
 bool FileMapCloseHandle(int hFileMapping); //     .
 //======================================================================================================================================================================
 // 6.               .
 //          .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseHandleFile(int hFileUser); //    .
 //======================================================================================================================================================================
 // 7.         .      .
 //      TRUE       ,  FALSE,       .
 bool FileMapCloseName(string sNameFileMap); //   .
 //======================================================================================================================================================================
 // 8.     .      -1.
 int FileMapNumberActive();
 //======================================================================================================================================================================
 // 9.    .         ,  NULL.    
 //                (    ),    NULL.
 int FileMapOpen(string sNameFileMap); //   .
 //======================================================================================================================================================================
 //10.        .   TRUE   ,  FALSE.
 bool FileMapResize(string sNameFileMap, //   .
                    int    nMemorySize); //      .
 //======================================================================================================================================================================
 //11.        .
 int FileMapSize(string sNameFileMap); //   .
 //======================================================================================================================================================================
 //
 //                .    
 //
 //======================================================================================================================================================================
 //12.           /       
 //                   .  
 //                ,  NULL.      
 //     (  ),   NULL.
 int FileMapCreateViewOfFile(int    hFileUser,    //    .
                             string sNameFileMap, //    .
                             int    nMemorySize); //      .
 //======================================================================================================================================================================
 //13.                 .
 //                  ,  NULL.    
 //                (  ),    NULL.
 int FileMapOpenViewOfFile(string sNameFileMap); //   .
 //======================================================================================================================================================================
 //14.          .
 //                  ,  NULL.
 int FileMapViewOfFile(int hMapping); //    .
 //======================================================================================================================================================================
 //15.          .
 //          TRUE  FALSE   .
 bool FileMapUnViewOfFile(int pcAddress); //          .
 //======================================================================================================================================================================
 //
 //           .    
 //
 //======================================================================================================================================================================
 //16.           BOOL     .
 //        INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteBool(string sNameFileMap, //   .
                      int    nStartByte,   //      ,     .
                      int    nValue);      //   BOOL     .
 //======================================================================================================================================================================
 //17.           CHAR     .
 //        INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteChar(string sNameFileMap, //   .
                      int    nStartByte,   //      ,     .
                      int    nValue);      //   CHAR     .
 //======================================================================================================================================================================
 //18.           UNSIGNED CHAR     .
 //        INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteUnsChar(string sNameFileMap, //   .
                         int    nStartByte,   //      ,     .
                         int    nValue);      //   UNSIGNED CHAR     .
 //======================================================================================================================================================================
 //19.           SHORT     .
 //        INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteShort(string sNameFileMap, //   .
                       int    nStartByte,   //      ,     .
                       int    nValue);      //   SHORT     .
 //======================================================================================================================================================================
 //20.           UNSIGNED SHORT     .
 //        INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteUnsShort(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int    nValue);      //   UNSIGNED SHORT     .
 //======================================================================================================================================================================
 //21.           INT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteInt(string sNameFileMap, //   .
                     int    nStartByte,   //      ,     .
                     int    nValue);      //   INT     .
 //======================================================================================================================================================================
 //22.           FLOAT     .
 //        DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteFloat(string sNameFileMap, //   .
                       int    nStartByte,   //      ,     .
                       double dValue);      //   FLOAT     .
 //======================================================================================================================================================================
 //23.           DOUBLE     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2     ;
 //                      -3      ;
 //                      -4      .
 int FileMapWriteDouble(string sNameFileMap, //   .
                        int    nStartByte,   //      ,     .
                        double dValue);      //   DOUBLE     .
 //======================================================================================================================================================================
 //24.              .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteString(string sNameFileMap, //   .
                        int    nStartByte,   //      ,     .
                        string sString);     //      .
 //======================================================================================================================================================================
 //
 //                  .    
 //
 //======================================================================================================================================================================
 //25.              BOOL     .
 //         .     INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteBool(int pcAddress,  //          .
                            int nStartByte, //      ,      .
                            int nValue);    //   BOOL     .
 //======================================================================================================================================================================
 //26.              CHAR     .
 //         .     INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteChar(int pcAddress,  //          .
                            int nStartByte, //      ,      .
                            int nValue);    //   CHAR     .
 //======================================================================================================================================================================
 //27.              CHAR     .
 //         .     INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteUnsChar(int pcAddress,  //          .
                               int nStartByte, //      ,      .
                               int nValue);    //   UNSIGNED CHAR     .
 //======================================================================================================================================================================
 //28.              SHORT     .
 //         .     INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteShort(int pcAddress,  //          .
                             int nStartByte, //      ,      .
                             int nValue);    //   SHORT     .
 //======================================================================================================================================================================
 //29.              UNSIGNED SHORT     .
 //         .     INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteUnsShort(int pcAddress,  //          .
                                int nStartByte, //      ,      .
                                int nValue);    //   UNSIGNED SHORT     .
 //======================================================================================================================================================================
 //30.              INT     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteInt(int pcAddress,  //          .
                           int nStartByte, //      ,      .
                           int nValue);    //   INT     .
 //======================================================================================================================================================================
 //31.              FLOAT     .
 //        DOUBLE  FLOAT     .      .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteFloat(int    pcAddress,  //          .
                             int    nStartByte, //      ,      .
                             double dValue);    //   FLOAT     .
 //======================================================================================================================================================================
 //32.              DOUBLE     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteDouble(int    pcAddress,  //          .
                              int    nStartByte, //      ,      .
                              double dValue);    //   DOUBLE     .
 //======================================================================================================================================================================
 //33.                 .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1      ;
 //                      -2      ;
 //                      -3    .
 int FileMapSimpleWriteString(int    pcAddress,  //          .
                              int    nStartByte, //      ,      .
                              string sString);   //      .
 //======================================================================================================================================================================
 //
 //           .    
 //
 //======================================================================================================================================================================
 //34.        BOOL     .
 //         FALSE   .
 bool FileMapReadBool(string sNameFileMap, //   .
                      int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //35.        CHAR     .
 //         NULL   .
 int FileMapReadChar(string sNameFileMap, //   .
                     int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //36.        UNSIGNED CHAR     .
 //         NULL   .
 int FileMapReadUnsChar(string sNameFileMap, //   .
                        int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //37.        SHORT     .
 //         NULL   .
 int FileMapReadShort(string sNameFileMap, //   .
                      int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //38.        UNSIGNED SHORT     .
 //         NULL   .
 int FileMapReadUnsShort(string sNameFileMap, //   .
                         int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //39.        INT     .
 //         NULL   .
 int FileMapReadInt(string sNameFileMap, //   .
                    int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //40.        FLOAT     .
 //         NULL   .
 //        FLOAT     DOUBLE.
 double FileMapReadFloat(string sNameFileMap, //   .
                         int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //41.        DOUBLE     .
 //         NULL   .
 double FileMapReadDouble(string sNameFileMap, //   .
                          int    nStartByte);  //      ,     .
 //======================================================================================================================================================================
 //42.           .
 //         .      NULL.
 string FileMapReadString(string sNameFileMap,   //   .
                          int    nStartByte,     //      ,     .
                          string sBuffer,        //    .
                          int    nLengthString); //      ().
 //======================================================================================================================================================================
 //
 //                  .    
 //
 //======================================================================================================================================================================
 //43.              BOOL     .
 //         .      FALSE   .
 bool FileMapSimpleReadBool(int pcAddress,   //          .
                            int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //44.              CHAR     .
 //         .      NULL   .
 int FileMapSimpleReadChar(int pcAddress,   //          .
                           int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //45.              UNSIGNED CHAR     .
 //         .      NULL   .
 int FileMapSimpleReadUnsChar(int pcAddress,   //          .
                              int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //46.              SHORT     .
 //         .      NULL   .
 int FileMapSimpleReadShort(int pcAddress,   //          .
                            int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //47.              UNSIGNED SHORT     .
 //         .      NULL   .
 int FileMapSimpleReadUnsShort(int pcAddress,   //          .
                               int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //48.              INT     .
 //         .      NULL   .
 int FileMapSimpleReadInt(int pcAddress,   //          .
                          int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //49.              FLOAT     .
 //         .      NULL   .
 double FileMapSimpleReadFloat(int pcAddress,   //          .
                               int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //50.              DOUBLE     .
 //         .      NULL   .
 double FileMapSimpleReadDouble(int pcAddress,   //          .
                                int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //51.                 .
 //         .      .
 //        : "Error_1"      ;
 //                                        "Error_2"      ;
 string FileMapSimpleReadString(int pcAddress,   //          .
                                int nStartByte); //      ,      .
 //======================================================================================================================================================================
 //
 //         .    
 //
 //======================================================================================================================================================================
 //52.             BOOL     .
 //        INT  BOOL     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteBoolArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           bool&  abArray[],    //       BOOL     .
                           int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //53.             CHAR     .
 //        INT  CHAR     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteCharArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           int&   aiArray[],    //       CHAR     .
                           int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //54.             UNSIGNED CHAR     .
 //        INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteUnsCharArray(string sNameFileMap, //   .
                              int    nStartByte,   //      ,     .
                              int&   aiArray[],    //       UNSIGNED CHAR     .
                              int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //55.             SHORT     .
 //        INT  SHORT     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteShortArray(string sNameFileMap, //   .
                            int    nStartByte,   //      ,     .
                            int&   aiArray[],    //       SHORT     .
                            int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //56.             UNSIGNED SHORT     .
 //        INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteUnsShortArray(string sNameFileMap, //   .
                               int    nStartByte,   //      ,     .
                               int&   aiArray[],    //       UNSIGNED SHORT     .
                               int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //57.             INT     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteIntArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int&   aiArray[],    //       INT     .
                          int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //58.             FLOAT     .
 //        DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteFloatArray(string  sNameFileMap, //   .
                            int     nStartByte,   //      ,     .
                            double& adArray[],    //       FLOAT     .
                            int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //59.             DOUBLE     .
 //     : 1   ;
 //                       0        ;
 //                      -1        ;
 //                      -2      ;
 //                      -3     ;
 //                      -4      ;
 //                      -5      .
 int FileMapWriteDoubleArray(string  sNameFileMap, //   .
                             int     nStartByte,   //      ,     .
                             double& adArray[],    //       DOUBLE     .
                             int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //
 //                .    
 //
 //======================================================================================================================================================================
 //60.                BOOL     .
 //         .     INT  BOOL     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteBoolArray(int   pcAddress,   //          .
                                 int   nStartByte,  //      ,      .
                                 bool& abArray[],   //       BOOL     .
                                 int   nSizeArray); //  .
 //======================================================================================================================================================================
 //61.                CHAR     .
 //         .     INT  CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteCharArray(int  pcAddress,   //          .
                                 int  nStartByte,  //      ,      .
                                 int& aiArray[],   //       CHAR     .
                                 int  nSizeArray); //  .
 //======================================================================================================================================================================
 //62.                UNSIGNED CHAR     .
 //         .     INT  UNSIGNED CHAR     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteUnsCharArray(int  pcAddress,   //          .
                                    int  nStartByte,  //      ,      .
                                    int& aiArray[],   //       CHAR     .
                                    int  nSizeArray); //  .
 //======================================================================================================================================================================
 //63.                SHORT     .
 //         .     INT  SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteShortArray(int  pcAddress,   //          .
                                  int  nStartByte,  //      ,      .
                                  int& aiArray[],   //       SHORT     .
                                  int  nSizeArray); //  .
 //======================================================================================================================================================================
 //64.                UNSIGNED SHORT     .
 //         .     INT  UNSIGNED SHORT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteUnsShortArray(int  pcAddress,   //          .
                                     int  nStartByte,  //      ,      .
                                     int& aiArray[],   //       UNSIGNED SHORT     .
                                     int  nSizeArray); //  .
 //======================================================================================================================================================================
 //65.                INT     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteIntArray(int  pcAddress,   //          .
                                int  nStartByte,  //      ,      .
                                int& aiArray[],   //       INT     .
                                int  nSizeArray); //  .
 //======================================================================================================================================================================
 //66.                FLOAT     .
 //         .     DOUBLE  FLOAT     .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteFloatArray(int     pcAddress,   //          .
                                  int     nStartByte,  //      ,      .
                                  double& adArray[],   //       FLOAT     .
                                  int     nSizeArray); //  .
 //======================================================================================================================================================================
 //67.                DOUBLE     .
 //         .
 //     : 1   ;
 //                       0   ;
 //                      -1        ;
 //                      -2      ;
 //                      -3      .
 int FileMapSimpleWriteDoubleArray(int     pcAddress,   //          .
                                   int     nStartByte,  //      ,      .
                                   double& adArray[],   //       DOUBLE     .
                                   int     nSizeArray); //  .
 //======================================================================================================================================================================
 //
 //        .    
 //
 //======================================================================================================================================================================
 //68.        BOOL       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadBoolArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          bool&  abArray[],    //          BOOL   .
                          int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //69.        CHAR       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadCharArray(string sNameFileMap, //   .
                          int    nStartByte,   //      ,     .
                          int&   aiArray[],    //          CHAR   .
                          int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //70.        UNSIGNED CHAR       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadUnsCharArray(string sNameFileMap, //   .
                             int    nStartByte,   //      ,     .
                             int&   aiArray[],    //          UNSIGNED CHAR   .
                             int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //71.        SHORT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadShortArray(string sNameFileMap, //   .
                           int    nStartByte,   //      ,     .
                           int&   aiArray[],    //          SHORT   .
                           int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //72.        UNSIGNED SHORT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadUnsShortArray(string sNameFileMap, //   .
                              int    nStartByte,   //      ,     .
                              int&   aiArray[],    //          UNSIGNED SHORT   .
                              int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //73.        INT       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadIntArray(string sNameFileMap, //   .
                         int    nStartByte,   //      ,     .
                         int&   aiArray[],    //          INT   .
                         int    nSizeArray);  //  .
 //======================================================================================================================================================================
 //74.        FLOAT       .
 //        FLOAT     DOUBLE    .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadFloatArray(string  sNameFileMap, //   .
                           int     nStartByte,   //      ,     .
                           double& adArray[],    //          FLOAT   .
                           int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //75.        DOUBLE       .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3     ;
 //                       -4      ;
 //                       -5      .
 int FileMapReadDoubleArray(string  sNameFileMap, //   .
                            int     nStartByte,   //      ,     .
                            double& adArray[],    //          DOUBLE   .
                            int     nSizeArray);  //  .
 //======================================================================================================================================================================
 //
 //                .    
 //
 //======================================================================================================================================================================
 //76.              BOOL       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadBoolArray(int   pcAddress,   //          .
                                int   nStartByte,  //      ,      .
                                bool& abArray[],   //          BOOL   .
                                int   nSizeArray); //  .
 //======================================================================================================================================================================
 //77.              CHAR       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadCharArray(int  pcAddress,   //          .
                                int  nStartByte,  //      ,      .
                                int& aiArray[],   //          CHAR   .
                                int  nSizeArray); //  .
 //======================================================================================================================================================================
 //78.              UNSIGNED CHAR       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadUnsCharArray(int  pcAddress,   //          .
                                   int  nStartByte,  //      ,      .
                                   int& aiArray[],   //          UNSIGNED CHAR   .
                                   int  nSizeArray); //  .
 //======================================================================================================================================================================
 //79.              SHORT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadShortArray(int  pcAddress,   //          .
                                 int  nStartByte,  //      ,      .
                                 int& aiArray[],   //          SHORT   .
                                 int  nSizeArray); //  .
 //======================================================================================================================================================================
 //80.              UNSIGNED SHORT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadUnsShortArray(int  pcAddress,   //          .
                                    int  nStartByte,  //      ,      .
                                    int& aiArray[],   //          UNSIGNED SHORT   .
                                    int  nSizeArray); //  .
 //======================================================================================================================================================================
 //81.              INT       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadIntArray(int  pcAddress,   //          .
                               int  nStartByte,  //      ,      .
                               int& aiArray[],   //          INT   .
                               int  nSizeArray); //  .
 //======================================================================================================================================================================
 //83.              FLOAT       .
 //         .     FLOAT     DOUBLE    .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadFloatArray(int     pcAddress,   //          .
                                 int     nStartByte,  //      ,      .
                                 double& adArray[],   //          FLOAT   .
                                 int     nSizeArray); //  .
 //======================================================================================================================================================================
 //83.              DOUBLE       .
 //         .
 //     : 1   ;
 //                        0   ;
 //                       -1      ;
 //                       -2      ;
 //                       -3      .
 int FileMapSimpleReadDoubleArray(int     pcAddress,   //          .
                                  int     nStartByte,  //      ,      .
                                  double& adArray[],   //          DOUBLE   .
                                  int     nSizeArray); //  .
 //======================================================================================================================================================================
 //
#import
//

